<?php

class Application_Form_Case extends Zend_Form
{

    public function init()
    {
        /* Form Elements & Other Definitions Here ... */
        $token = new Zend_Form_Element_Hash("token");
        $token->setTimeout(Application_Model_Cache_Config::getConfig("FORM_CSRF_TOKEN_EXPIRE"));
        
        $case_num = new Zend_Form_Element_Text("case_num");
        $case_num->setLabel("Notification")->setRequired(true);
        
        $case_account = new Zend_Form_Element_Text("case_account");
        $case_account->setLabel("Cont. Account")->setRequired(true);
        
        $case_name = new Zend_Form_Element_Text("case_name");
        $case_name->setLabel("Customer Name")->setRequired(true);
        
        $case_address = new Zend_Form_Element_Text("case_address");
        $case_address->setLabel("Address")->setRequired(true);
        
        $case_mobile = new Zend_Form_Element_Text("case_mobile");
        $case_mobile->setLabel("Mobile")->setRequired(true);
        
        $case_mobile_other = new Zend_Form_Element_Text("case_mobile_other");
        $case_mobile_other->setLabel("Alternate Mobile");
        
        $case_register_by = new Zend_Form_Element_Text("case_register_by");
        $case_register_by->setLabel("Register By");
        
        $case_date = new Zend_Form_Element_Text("case_date");
        $case_date->setLabel("Register Date")->setRequired(true)->setAttrib('class', 'datepick');
        
        $case_short_code = new Zend_Form_Element_Text("case_short_code");
        $case_short_code->setLabel("Short text for Code");
        
        $case_segment = new Zend_Form_Element_Text("case_segment");
        $case_segment->setLabel("Consumer Segment");
        
        $case_conn_type = new Zend_Form_Element_Text("case_conn_type");
        $case_conn_type->setLabel("Connection Type");
        
        $case_rate_cat = new Zend_Form_Element_Text("case_rate_cat");
        $case_rate_cat->setLabel("Rate Category");
        
        $save = new Zend_Form_Element_Submit("save");
        $save->setLabel("Save")->setRequired(true)->setAttrib('class', 'btn btn-primary');
        
        $this->addElements(array($token,
        $case_num,
        $case_account,
        $case_name,
        $case_address,
        $case_mobile,
        $case_mobile_other,
        $case_register_by,
        $case_date,
        $case_short_code,
        //$case_segment,
        //$case_conn_type,
        //$case_rate_cat,
        $save));
        
    }

}

