<?php

class Application_Form_CaseImport extends Zend_Form
{

    public function init()
    {
        /* Form Elements & Other Definitions Here ... */
        $token = new Zend_Form_Element_Hash("token");
        $token->setTimeout(Application_Model_Cache_Config::getConfig("FORM_CSRF_TOKEN_EXPIRE"));
        
        $case_file = new Zend_Form_Element_File("case_file");
        $case_file->setLabel("File")->setRequired(true);
        $filename = date('d_M_y_H_i_s') . '_case_' .((null != $case_file->getFileName(null, false)) ? $case_file->getFileName(null, false) : '');
        $case_file->setDestination(Application_Model_Cache_Config::getConfig('UPLOAD_FOLDER_NAME').'/'.Application_Model_Cache_Config::getConfig('TEMP_FOLDER').'/') 
            ->addFilter('Rename', $filename)
            ->addValidator('Extension', false, 'csv')
            ->setDescription('Only .csv files allowed');
        
        $save = new Zend_Form_Element_Submit("save");
        $save->setLabel("Import Case")->setRequired(true)->setAttrib('class', 'btn btn-primary');
        
        $this->addElements(array($token,
        $case_file,
        $save));
    }


}

