<?php

class Application_Form_Category extends Zend_Form
{

    public function init()
    {
        /* Form Elements & Other Definitions Here ... */
        $token = new Zend_Form_Element_Hash("token");
        $token->setTimeout(Application_Model_Cache_Config::getConfig("FORM_CSRF_TOKEN_EXPIRE"));
        
        $category_type = new Zend_Form_Element_Hidden("category_type");
        $category_type->setValue($this->getAttrib('type'));
        
        $category_title = new Zend_Form_Element_Text("category_title");
        $category_title->setLabel("Category")->setRequired(true);
        
        $category_desc = new Zend_Form_Element_Textarea("category_desc");
        $category_desc->setLabel("Description")->setRequired(true)->setAttrib('rows', 5);
        
        $category_parent = new Zend_Form_Element_Select("category_parent");
        $category_parent->setLabel("Parent")->setRequired(true);
        $category_parent->addMultiOption('0', '-- Select Parent category --');
        $obj_cat = new Application_Model_CategoryLogic(-1);
        foreach($obj_cat->getParentCategory($this->getAttrib('type')) as $row) {
            $category_parent->addMultiOption($row->id, $row->category_title);
        }
        
        $category_status = new Zend_Form_Element_Radio("category_status");
        $category_status->setLabel("Status")->setRequired(true);
        $category_status->addMultiOptions(Application_Model_Cache_Config::getConfig('STATUS_TYPE'));
        
        $save = new Zend_Form_Element_Submit("save");
        $save->setLabel("Save")->setRequired(true)->setAttrib('class', 'btn btn-blue4');
        
        $this->addElements(array($token,
        $category_type,
        $category_title,
        $category_desc,
        $category_parent,
        $category_status,
        $save));
    }


}

