<?php

class Application_Form_Install extends Zend_Form
{

    public function init()
    {
        /* Form Elements & Other Definitions Here ... */
        $token = new Zend_Form_Element_Hash("token");
        $token->setTimeout(Application_Model_Cache_Config::getConfig("FORM_CSRF_TOKEN_EXPIRE"));
        
        $case_id = new Zend_Form_Element_Hidden("case_id");
        
        $install_unique_id = new Zend_Form_Element_Text("install_unique_id");
        $install_unique_id->setLabel("Unique ID")->setRequired(true);
        
        $install_ac_make = new Zend_Form_Element_Select("install_ac_make");
        $install_ac_make->setLabel("Install AC Make")->setRequired(true);
        $install_ac_make->addMultiOption('', '-- Select AC Make --');
        $install_ac_make->addMultiOptions(Application_Model_Cache_Config::getConfig('INSTALL_AC_MAKE'));
        
        $install_ac_model = new Zend_Form_Element_Text("install_ac_model");
        $install_ac_model->setLabel("Model")->setRequired(true);
        
        $install_ac_capacity = new Zend_Form_Element_Select("install_ac_capacity");
        $install_ac_capacity->setLabel("Choiced AC Make")->setRequired(true);
        $install_ac_capacity->addMultiOption('', '-- Select AC Capacity --');
        $install_ac_capacity->addMultiOptions(Application_Model_Cache_Config::getConfig('INSTALL_AC_CAPACITY'));
        
        $install_srn = new Zend_Form_Element_Text("install_srn");
        $install_srn->setLabel("SR. No.")->setRequired(true);
        
        $install_date = new Zend_Form_Element_Text("install_date");
        $install_date->setLabel("Install Date")->setRequired(true)->setAttrib('class', 'datepick');
        
        $install_old_make = new Zend_Form_Element_Text("install_old_make");
        $install_old_make->setLabel("Old AC Make");
        
        $install_old_model = new Zend_Form_Element_Text("install_old_model");
        $install_old_model->setLabel("Old AC Model");
        
        $install_old_capacity = new Zend_Form_Element_Text("install_old_capacity");
        $install_old_capacity->setLabel("Old AC Capacity");
        
        $install_old_vendor = new Zend_Form_Element_Text("install_old_vendor");
        $install_old_vendor->setLabel("Old AC Vendor");
        
        $install_old_year = new Zend_Form_Element_Text("install_old_year");
        $install_old_year->setLabel("Old AC Year");
        
        $install_old_srn = new Zend_Form_Element_Text("install_old_srn");
        $install_old_srn->setLabel("Old AC SRN");
        
        $install_old_watt = new Zend_Form_Element_Text("install_old_watt");
        $install_old_watt->setLabel("Old AC Watt");
        
        $install_old_dispose = new Zend_Form_Element_Text("install_old_dispose");
        $install_old_dispose->setLabel("Old AC Disposing Date")->setAttrib('class', 'datepick');
        
        $install_pay_mode = new Zend_Form_Element_Select("install_pay_mode");
        $install_pay_mode->setLabel("Payment Mode")->setRequired(true);
        $install_pay_mode->addMultiOption('', '-- Select Payment Mode --');
        $install_pay_mode->addMultiOptions(Application_Model_Cache_Config::getConfig('PAYMENT_MODES'));
        
        $install_remarks = new Zend_Form_Element_Textarea("install_remarks");
        $install_remarks->setLabel("Remarks")->setAttrib('rows', 5);
        
        $save = new Zend_Form_Element_Submit("save");
        $save->setLabel("Save")->setRequired(true)->setAttrib('class', 'btn btn-blue4');
        
        $this->addElements(array($token,
        $case_id,
        $install_unique_id,
        $install_ac_make,
        $install_ac_model,
        $install_ac_capacity,
        $install_srn,
        $install_date,
        $install_old_make,
        $install_old_model,
        $install_old_capacity,
        $install_old_vendor,
        $install_old_year,
        $install_old_srn,
        $install_old_watt,
        $install_old_dispose,
        $install_pay_mode,
        $install_remarks,
        $save));
    }


}

