<?php

class Application_Form_Invoice extends Zend_Form
{

    public function init()
    {
        /* Form Elements & Other Definitions Here ... */
        $token = new Zend_Form_Element_Hash("token");
        $token->setTimeout(Application_Model_Cache_Config::getConfig("FORM_CSRF_TOKEN_EXPIRE"));
        
        $case_id = new Zend_Form_Element_Hidden("case_id");
        
        $invoice_num = new Zend_Form_Element_Text("invoice_num");
        $invoice_num->setLabel("Invoice Number")->setRequired(true);
        
        $invoice_date = new Zend_Form_Element_Text("invoice_date");
        $invoice_date->setLabel("Invoice Date")->setRequired(true)->setAttrib('class', 'datepick');
        
        $invoice_net_amount = new Zend_Form_Element_Text("invoice_net_amount");
        $invoice_net_amount->setLabel("Net Amount");
        
        $invoice_rebate_amount = new Zend_Form_Element_Text("invoice_rebate_amount");
        $invoice_rebate_amount->setLabel("Rebate Amount");
        
        $invoice_disposal_amount = new Zend_Form_Element_Text("invoice_disposal_amount");
        $invoice_disposal_amount->setLabel("Disposal AC Amount");
        
        $invoice_remarks = new Zend_Form_Element_Textarea("invoice_remarks");
        $invoice_remarks->setLabel("Remarks")->setAttrib('rows', 5);
        
        $save = new Zend_Form_Element_Submit("save");
        $save->setLabel("Save")->setRequired(true)->setAttrib('class', 'btn btn-blue4');
        
        $this->addElements(array($token,
        $case_id,
        $invoice_num,
        $invoice_date,
        $invoice_net_amount,
        $invoice_rebate_amount,
        $invoice_disposal_amount,
        $invoice_remarks,
        $save));
    }


}

