<?php

class Application_Form_Schedule extends Zend_Form
{

    public function init()
    {
        /* Form Elements & Other Definitions Here ... */
        $token = new Zend_Form_Element_Hash("token");
        $token->setTimeout(Application_Model_Cache_Config::getConfig("FORM_CSRF_TOKEN_EXPIRE"));
        
        $case_id = new Zend_Form_Element_Hidden("case_id");
        
        $sched_date = new Zend_Form_Element_Text("sched_date");
        $sched_date->setLabel("Schedule Date")->setRequired(true)->setAttrib('class', 'datepick');
        
        $sched_time = new Zend_Form_Element_Text("sched_time");
        $sched_time->setLabel("Schedule Time")->setAttrib('class', 'timepicker');
        
        $sched_ac_type = new Zend_Form_Element_Select("sched_ac_type");
        $sched_ac_type->setLabel("AC Type")->setRequired(true);
        $sched_ac_type->addMultiOption('', '-- Select AC Type --');
        $sched_ac_type->addMultiOptions(Application_Model_Cache_Config::getConfig('INSTALL_AC_TYPE'));
        
        $sched_ac_capacity = new Zend_Form_Element_Select("sched_ac_capacity");
        $sched_ac_capacity->setLabel("Capacity")->setRequired(true);
        $sched_ac_capacity->addMultiOption('', '-- Select Capacity --');
        $sched_ac_capacity->addMultiOptions(Application_Model_Cache_Config::getConfig('INSTALL_AC_CAPACITY'));
        
        $sched_remarks = new Zend_Form_Element_Textarea("sched_remarks");
        $sched_remarks->setLabel("Remarks")->setAttrib('rows', 5);
        
        $save = new Zend_Form_Element_Submit("save");
        $save->setLabel("Save")->setRequired(true)->setAttrib('class', 'btn btn-blue4');
        
        $this->addElements(array($token,
        $case_id,
        $sched_date,
        $sched_time,
        $sched_ac_type,
        $sched_ac_capacity,
        $sched_remarks,
        $save));
    }


}

