<?php

class Application_Model_AC extends Zend_Db_Table_Abstract
{

    protected $_name = 'asit_ac';

    private $_id = null;

    private $_ac_company = null;

    private $_ac_model = null;

    private $_ac_capacity = null;

    private $_ac_mfg_year = null;

    private $_ac_status = null;

    private $_ac_updated_by = null;

    private $_ac_updated_date = null;

    private $_ac_created_by = null;

    private $_ac_created_date = null;

    /**
     * Constructor initialize primary key field value to set the set_id method. If
     * value = -1 then default object loaded.
     *
     * @var int id
     */
    public function __construct($id)
    {
        parent::__construct();
        $id = (int) $id;
        $this->set_id($id);
        if($id!=-1)
        {
          $this->fetch();
        }
    }

    /**
     * get id method is stand for get the value of id.
     *
     * @var int id
     */
    public function get_id()
    {
        return (int) $this->_id;
    }

    /**
     * set id method is stand for set the value of id.
     *
     * @var int id
     */
    public function set_id($value)
    {
        $this->_id = (int) $value;
    }

    /**
     * get ac_company method is stand for get the value of ac_company.
     *
     * @var varchar ac_company
     */
    public function get_ac_company()
    {
        return $this->_ac_company;
    }

    /**
     * set ac_company method is stand for set the value of ac_company.
     *
     * @var varchar ac_company
     */
    public function set_ac_company($value)
    {
        $this->_ac_company = $value;
    }

    /**
     * get ac_model method is stand for get the value of ac_model.
     *
     * @var varchar ac_model
     */
    public function get_ac_model()
    {
        return $this->_ac_model;
    }

    /**
     * set ac_model method is stand for set the value of ac_model.
     *
     * @var varchar ac_model
     */
    public function set_ac_model($value)
    {
        $this->_ac_model = $value;
    }

    /**
     * get ac_capacity method is stand for get the value of ac_capacity.
     *
     * @var varchar ac_capacity
     */
    public function get_ac_capacity()
    {
        return $this->_ac_capacity;
    }

    /**
     * set ac_capacity method is stand for set the value of ac_capacity.
     *
     * @var varchar ac_capacity
     */
    public function set_ac_capacity($value)
    {
        $this->_ac_capacity = $value;
    }

    /**
     * get ac_mfg_year method is stand for get the value of ac_mfg_year.
     *
     * @var year(4) ac_mfg_year
     */
    public function get_ac_mfg_year()
    {
        return $this->_ac_mfg_year;
    }

    /**
     * set ac_mfg_year method is stand for set the value of ac_mfg_year.
     *
     * @var year(4) ac_mfg_year
     */
    public function set_ac_mfg_year($value)
    {
        $this->_ac_mfg_year = $value;
    }

    /**
     * get ac_status method is stand for get the value of ac_status.
     *
     * @var varchar ac_status
     */
    public function get_ac_status()
    {
        return $this->_ac_status;
    }

    /**
     * set ac_status method is stand for set the value of ac_status.
     *
     * @var varchar ac_status
     */
    public function set_ac_status($value)
    {
        $this->_ac_status = $value;
    }

    /**
     * get ac_updated_by method is stand for get the value of ac_updated_by.
     *
     * @var int ac_updated_by
     */
    public function get_ac_updated_by()
    {
        return (int) $this->_ac_updated_by;
    }

    /**
     * set ac_updated_by method is stand for set the value of ac_updated_by.
     *
     * @var int ac_updated_by
     */
    public function set_ac_updated_by($value)
    {
        $this->_ac_updated_by = (int) $value;
    }

    /**
     * get ac_updated_date method is stand for get the value of ac_updated_date.
     *
     * @var timestamp ac_updated_date
     */
    public function get_ac_updated_date()
    {
        return date("d-M-Y (H:i:s)", strtotime($this->_ac_updated_date));
    }

    /**
     * set ac_updated_date method is stand for set the value of ac_updated_date.
     *
     * @var timestamp ac_updated_date
     */
    public function set_ac_updated_date($value)
    {
        $this->_ac_updated_date = date("Y-m-d H:i:s", strtotime($value));
    }

    /**
     * get ac_created_by method is stand for get the value of ac_created_by.
     *
     * @var int ac_created_by
     */
    public function get_ac_created_by()
    {
        return (int) $this->_ac_created_by;
    }

    /**
     * set ac_created_by method is stand for set the value of ac_created_by.
     *
     * @var int ac_created_by
     */
    public function set_ac_created_by($value)
    {
        $this->_ac_created_by = (int) $value;
    }

    /**
     * get ac_created_date method is stand for get the value of ac_created_date.
     *
     * @var timestamp ac_created_date
     */
    public function get_ac_created_date()
    {
        return date("d-M-Y (H:i:s)", strtotime($this->_ac_created_date));
    }

    /**
     * set ac_created_date method is stand for set the value of ac_created_date.
     *
     * @var timestamp ac_created_date
     */
    public function set_ac_created_date($value)
    {
        $this->_ac_created_date = date("Y-m-d H:i:s", strtotime($value));
    }

    /**
     * fetch data from asit_ac by set id thru constructor.
     *
     * @var int id
     * @var varchar ac_company
     * @var varchar ac_model
     * @var varchar ac_capacity
     * @var year(4) ac_mfg_year
     * @var varchar ac_status
     * @var int ac_updated_by
     * @var timestamp ac_updated_date
     * @var int ac_created_by
     * @var timestamp ac_created_date
     */
    public function fetch()
    {
        $select=$this->select()->where("id = ?",$this->get_id());
        $row=$this->fetchRow($select);
        if($row!=null){
          $this->set_id($row->id);
          $this->set_ac_company($row->ac_company);
          $this->set_ac_model($row->ac_model);
          $this->set_ac_capacity($row->ac_capacity);
          $this->set_ac_mfg_year($row->ac_mfg_year);
          $this->set_ac_status($row->ac_status);
          $this->set_ac_updated_by($row->ac_updated_by);
          $this->set_ac_updated_date($row->ac_updated_date);
          $this->set_ac_created_by($row->ac_created_by);
          $this->set_ac_created_date($row->ac_created_date);
        }
    }

    /**
     * save method is stand for saving the data, if id = -1 then data insert as a new
     * record and if id is set via constructor then data should update
     *
     * @var varchar ac_company
     * @var varchar ac_model
     * @var varchar ac_capacity
     * @var year(4) ac_mfg_year
     * @var varchar ac_status
     * @var int ac_updated_by
     * @var int ac_created_by
     */
    public function save()
    {
        $data = array(
          "ac_company" => $this->get_ac_company(),
          "ac_model" => $this->get_ac_model(),
          "ac_capacity" => $this->get_ac_capacity(),
          "ac_mfg_year" => $this->get_ac_mfg_year(),
          "ac_status" => $this->get_ac_status(),
          "ac_updated_by" => $this->get_ac_updated_by(),
          "ac_created_by" => $this->get_ac_created_by());
        if($this->get_id()==-1)
        {
          return $this->insert($data);
        }
        else
        {
          $where = $this->getAdapter()->quoteInto("id = ?", $this->get_id());
          $this->update($data, $where);
        }
    }

    /**
     * remove method delete the record from asit_ac by id.
     *
     * @var int id
     */
    public function remove()
    {
        $where = $this->getAdapter()->quoteInto("id = ?", $this->get_id());
        $this->delete($where);
    }

    /**
     * fetch_list_select stand for selecting all records.
     */
    public function fetch_list_select()
    {
        $select = $this->select();
        return $select;
    }

    /**
     * get_ac_company_by_id method is stand for get the value ofac_company By id.
     *
     * @var varchar ac_company
     */
    public function get_ac_company_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return $this->get_ac_company();
    }

    /**
     * get_ac_model_by_id method is stand for get the value ofac_model By id.
     *
     * @var varchar ac_model
     */
    public function get_ac_model_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return $this->get_ac_model();
    }

    /**
     * get_ac_capacity_by_id method is stand for get the value ofac_capacity By id.
     *
     * @var varchar ac_capacity
     */
    public function get_ac_capacity_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return $this->get_ac_capacity();
    }

    /**
     * get_ac_mfg_year_by_id method is stand for get the value ofac_mfg_year By id.
     *
     * @var year(4) ac_mfg_year
     */
    public function get_ac_mfg_year_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return $this->get_ac_mfg_year();
    }

    /**
     * get_ac_status_by_id method is stand for get the value ofac_status By id.
     *
     * @var varchar ac_status
     */
    public function get_ac_status_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return $this->get_ac_status();
    }

    /**
     * get_ac_updated_by_by_id method is stand for get the value ofac_updated_by By id.
     *
     * @var int ac_updated_by
     */
    public function get_ac_updated_by_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return (int) $this->get_ac_updated_by();
    }

    /**
     * get_ac_updated_date_by_id method is stand for get the value ofac_updated_date By
     * id.
     *
     * @var timestamp ac_updated_date
     */
    public function get_ac_updated_date_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return date("d-M-Y (H:i:s)", strtotime($this->get_ac_updated_date()));
    }

    /**
     * get_ac_created_by_by_id method is stand for get the value ofac_created_by By id.
     *
     * @var int ac_created_by
     */
    public function get_ac_created_by_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return (int) $this->get_ac_created_by();
    }

    /**
     * get_ac_created_date_by_id method is stand for get the value ofac_created_date By
     * id.
     *
     * @var timestamp ac_created_date
     */
    public function get_ac_created_date_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return date("d-M-Y (H:i:s)", strtotime($this->get_ac_created_date()));
    }


}
