<?php

class Application_Model_ACLogic extends Application_Model_AC
{
    
    public function fetchDataTableSelect() 
    {
        $columns = array('ac_company', 'ac_model', 'ac_capacity', 'ac_mfg_year', 'action');
        $obj_data = new Application_Model_Util_Datatable((new Application_Model_ACLogic(-1)), $columns);
        $where = $obj_data->get_where();
        $where->where('ac_status != ?', 'D');
        $obj_data->set_where($where);
        $rows = $obj_data->fetch();
        $results = array();
        $i = 0;
        $url = new Zend_View_Helper_Url();
        $enc = new Application_Model_Util_Encrypt();
        foreach($rows as $row)
        {
            $action = '';
            if(Application_Model_RolePermissionLogic::isPermitted("AC:Edit")) {
                $action = '<a href="'.$url->url(array("module"=>"dynasty", "controller"=>"ac", "action"=>"edit", "id"=>$enc->hideContent($row->id))).'"><input type="button" value="Edit" class="btn btn-info" /></a> ';
            }
            if(Application_Model_RolePermissionLogic::isPermitted("AC:Delete")) {
                $action .= '<a href="'.$url->url(array("module"=>"dynasty", "controller"=>"ac", "action"=>"delete", "id"=>$enc->hideContent($row->id))).'"><input type="button" value="Delete" class="btn btn-danger" /></a>';
            }
            $results[$i] = array($row->ac_company, $row->ac_model, $row->ac_capacity, $row->ac_mfg_year, $action);
            $i += 1;
        }
        return $obj_data->configureOutput($results);
    }
    
    public function fetchActiveACs() {
        return $this->fetchAll($this->select()->where('ac_status = ?', 'A')->order('ac_company')->order('ac_model')->order('ac_capacity'));
    }
    
}

