<?php

class Application_Model_Account extends Zend_Db_Table_Abstract
{

    protected $_name = 'asit_case_account';

    private $_id = null;

    private $_case_id = null;

    private $_invoice_num = null;

    private $_invoice_date = null;

    private $_invoice_net_amount = null;

    private $_invoice_rebate_amount = null;

    private $_invoice_disposal_amount = null;

    private $_invoice_pay_mode = null;

    private $_invoice_is_paid = null;

    private $_invoice_remarks = null;

    private $_invoice_status = null;

    private $_invoice_updated_by = null;

    private $_invoice_updated_date = null;

    private $_invoice_created_by = null;

    private $_invoice_created_date = null;

    /**
     * Constructor initialize primary key field value to set the set_id method. If
     * value = -1 then default object loaded.
     *
     * @var int id
     */
    public function __construct($id)
    {
        parent::__construct();
        $id = (int) $id;
        $this->set_id($id);
        if($id!=-1)
        {
          $this->fetch();
        }
    }

    /**
     * get id method is stand for get the value of id.
     *
     * @var int id
     */
    public function get_id()
    {
        return (int) $this->_id;
    }

    /**
     * set id method is stand for set the value of id.
     *
     * @var int id
     */
    public function set_id($value)
    {
        $this->_id = (int) $value;
    }

    /**
     * get case_id method is stand for get the value of case_id.
     *
     * @var int case_id
     */
    public function get_case_id()
    {
        return (int) $this->_case_id;
    }

    /**
     * set case_id method is stand for set the value of case_id.
     *
     * @var int case_id
     */
    public function set_case_id($value)
    {
        $this->_case_id = (int) $value;
    }

    /**
     * get invoice_num method is stand for get the value of invoice_num.
     *
     * @var varchar invoice_num
     */
    public function get_invoice_num()
    {
        return $this->_invoice_num;
    }

    /**
     * set invoice_num method is stand for set the value of invoice_num.
     *
     * @var varchar invoice_num
     */
    public function set_invoice_num($value)
    {
        $this->_invoice_num = $value;
    }

    /**
     * get invoice_date method is stand for get the value of invoice_date.
     *
     * @var date invoice_date
     */
    public function get_invoice_date()
    {
        return date("d-M-Y", strtotime($this->_invoice_date));
    }

    /**
     * set invoice_date method is stand for set the value of invoice_date.
     *
     * @var date invoice_date
     */
    public function set_invoice_date($value)
    {
        $this->_invoice_date = date("Y-m-d", strtotime($value));
    }

    /**
     * get invoice_net_amount method is stand for get the value of invoice_net_amount.
     *
     * @var double invoice_net_amount
     */
    public function get_invoice_net_amount()
    {
        return (double) $this->_invoice_net_amount;
    }

    /**
     * set invoice_net_amount method is stand for set the value of invoice_net_amount.
     *
     * @var double invoice_net_amount
     */
    public function set_invoice_net_amount($value)
    {
        $this->_invoice_net_amount = (double) $value;
    }

    /**
     * get invoice_rebate_amount method is stand for get the value of
     * invoice_rebate_amount.
     *
     * @var double invoice_rebate_amount
     */
    public function get_invoice_rebate_amount()
    {
        return (double) $this->_invoice_rebate_amount;
    }

    /**
     * set invoice_rebate_amount method is stand for set the value of
     * invoice_rebate_amount.
     *
     * @var double invoice_rebate_amount
     */
    public function set_invoice_rebate_amount($value)
    {
        $this->_invoice_rebate_amount = (double) $value;
    }

    /**
     * get invoice_disposal_amount method is stand for get the value of
     * invoice_disposal_amount.
     *
     * @var double invoice_disposal_amount
     */
    public function get_invoice_disposal_amount()
    {
        return (double) $this->_invoice_disposal_amount;
    }

    /**
     * set invoice_disposal_amount method is stand for set the value of
     * invoice_disposal_amount.
     *
     * @var double invoice_disposal_amount
     */
    public function set_invoice_disposal_amount($value)
    {
        $this->_invoice_disposal_amount = (double) $value;
    }

    /**
     * get invoice_pay_mode method is stand for get the value of invoice_pay_mode.
     *
     * @var varchar invoice_pay_mode
     */
    public function get_invoice_pay_mode()
    {
        return $this->_invoice_pay_mode;
    }

    /**
     * set invoice_pay_mode method is stand for set the value of invoice_pay_mode.
     *
     * @var varchar invoice_pay_mode
     */
    public function set_invoice_pay_mode($value)
    {
        $this->_invoice_pay_mode = $value;
    }

    /**
     * get invoice_is_paid method is stand for get the value of invoice_is_paid.
     *
     * @var varchar invoice_is_paid
     */
    public function get_invoice_is_paid()
    {
        return $this->_invoice_is_paid;
    }

    /**
     * set invoice_is_paid method is stand for set the value of invoice_is_paid.
     *
     * @var varchar invoice_is_paid
     */
    public function set_invoice_is_paid($value)
    {
        $this->_invoice_is_paid = $value;
    }

    /**
     * get invoice_remarks method is stand for get the value of invoice_remarks.
     *
     * @var varchar invoice_remarks
     */
    public function get_invoice_remarks()
    {
        return $this->_invoice_remarks;
    }

    /**
     * set invoice_remarks method is stand for set the value of invoice_remarks.
     *
     * @var varchar invoice_remarks
     */
    public function set_invoice_remarks($value)
    {
        $this->_invoice_remarks = $value;
    }

    /**
     * get invoice_status method is stand for get the value of invoice_status.
     *
     * @var varchar invoice_status
     */
    public function get_invoice_status()
    {
        return $this->_invoice_status;
    }

    /**
     * set invoice_status method is stand for set the value of invoice_status.
     *
     * @var varchar invoice_status
     */
    public function set_invoice_status($value)
    {
        $this->_invoice_status = $value;
    }

    /**
     * get invoice_updated_by method is stand for get the value of invoice_updated_by.
     *
     * @var int invoice_updated_by
     */
    public function get_invoice_updated_by()
    {
        return (int) $this->_invoice_updated_by;
    }

    /**
     * set invoice_updated_by method is stand for set the value of invoice_updated_by.
     *
     * @var int invoice_updated_by
     */
    public function set_invoice_updated_by($value)
    {
        $this->_invoice_updated_by = (int) $value;
    }

    /**
     * get invoice_updated_date method is stand for get the value of
     * invoice_updated_date.
     *
     * @var timestamp invoice_updated_date
     */
    public function get_invoice_updated_date()
    {
        return date("d-M-Y (H:i:s)", strtotime($this->_invoice_updated_date));
    }

    /**
     * set invoice_updated_date method is stand for set the value of
     * invoice_updated_date.
     *
     * @var timestamp invoice_updated_date
     */
    public function set_invoice_updated_date($value)
    {
        $this->_invoice_updated_date = date("Y-m-d H:i:s", strtotime($value));
    }

    /**
     * get invoice_created_by method is stand for get the value of invoice_created_by.
     *
     * @var int invoice_created_by
     */
    public function get_invoice_created_by()
    {
        return (int) $this->_invoice_created_by;
    }

    /**
     * set invoice_created_by method is stand for set the value of invoice_created_by.
     *
     * @var int invoice_created_by
     */
    public function set_invoice_created_by($value)
    {
        $this->_invoice_created_by = (int) $value;
    }

    /**
     * get invoice_created_date method is stand for get the value of
     * invoice_created_date.
     *
     * @var timestamp invoice_created_date
     */
    public function get_invoice_created_date()
    {
        return date("d-M-Y (H:i:s)", strtotime($this->_invoice_created_date));
    }

    /**
     * set invoice_created_date method is stand for set the value of
     * invoice_created_date.
     *
     * @var timestamp invoice_created_date
     */
    public function set_invoice_created_date($value)
    {
        $this->_invoice_created_date = date("Y-m-d H:i:s", strtotime($value));
    }

    /**
     * fetch data from asit_case_account by set id thru constructor.
     *
     * @var int id
     * @var int case_id
     * @var varchar invoice_num
     * @var date invoice_date
     * @var double invoice_net_amount
     * @var double invoice_rebate_amount
     * @var double invoice_disposal_amount
     * @var varchar invoice_pay_mode
     * @var varchar invoice_is_paid
     * @var varchar invoice_remarks
     * @var varchar invoice_status
     * @var int invoice_updated_by
     * @var timestamp invoice_updated_date
     * @var int invoice_created_by
     * @var timestamp invoice_created_date
     */
    public function fetch()
    {
        $select=$this->select()->where("id = ?",$this->get_id());
        $row=$this->fetchRow($select);
        if($row!=null){
          $this->set_id($row->id);
          $this->set_case_id($row->case_id);
          $this->set_invoice_num($row->invoice_num);
          $this->set_invoice_date($row->invoice_date);
          $this->set_invoice_net_amount($row->invoice_net_amount);
          $this->set_invoice_rebate_amount($row->invoice_rebate_amount);
          $this->set_invoice_disposal_amount($row->invoice_disposal_amount);
          $this->set_invoice_pay_mode($row->invoice_pay_mode);
          $this->set_invoice_is_paid($row->invoice_is_paid);
          $this->set_invoice_remarks($row->invoice_remarks);
          $this->set_invoice_status($row->invoice_status);
          $this->set_invoice_updated_by($row->invoice_updated_by);
          $this->set_invoice_updated_date($row->invoice_updated_date);
          $this->set_invoice_created_by($row->invoice_created_by);
          $this->set_invoice_created_date($row->invoice_created_date);
        }
    }

    /**
     * save method is stand for saving the data, if id = -1 then data insert as a new
     * record and if id is set via constructor then data should update
     *
     * @var int case_id
     * @var varchar invoice_num
     * @var date invoice_date
     * @var double invoice_net_amount
     * @var double invoice_rebate_amount
     * @var double invoice_disposal_amount
     * @var varchar invoice_pay_mode
     * @var varchar invoice_is_paid
     * @var varchar invoice_remarks
     * @var varchar invoice_status
     * @var int invoice_updated_by
     * @var int invoice_created_by
     */
    public function save()
    {
        $data = array(
          "case_id" => $this->get_case_id(),
          "invoice_num" => $this->get_invoice_num(),
          "invoice_date" => date("Y-m-d", strtotime($this->get_invoice_date())),
          "invoice_net_amount" => $this->get_invoice_net_amount(),
          "invoice_rebate_amount" => $this->get_invoice_rebate_amount(),
          "invoice_disposal_amount" => $this->get_invoice_disposal_amount(),
          "invoice_pay_mode" => $this->get_invoice_pay_mode(),
          "invoice_is_paid" => $this->get_invoice_is_paid(),
          "invoice_remarks" => $this->get_invoice_remarks(),
          "invoice_status" => $this->get_invoice_status(),
          "invoice_updated_by" => $this->get_invoice_updated_by(),
          "invoice_created_by" => $this->get_invoice_created_by());
        if($this->get_id()==-1)
        {
          return $this->insert($data);
        }
        else
        {
          $where = $this->getAdapter()->quoteInto("id = ?", $this->get_id());
          $this->update($data, $where);
        }
    }

    /**
     * remove method delete the record from asit_case_account by id.
     *
     * @var int id
     */
    public function remove()
    {
        $where = $this->getAdapter()->quoteInto("id = ?", $this->get_id());
        $this->delete($where);
    }

    /**
     * fetch_list_select stand for selecting all records.
     */
    public function fetch_list_select()
    {
        $select = $this->select();
        return $select;
    }

    /**
     * get_case_id_by_id method is stand for get the value ofcase_id By id.
     *
     * @var int case_id
     */
    public function get_case_id_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return (int) $this->get_case_id();
    }

    /**
     * get_invoice_num_by_id method is stand for get the value ofinvoice_num By id.
     *
     * @var varchar invoice_num
     */
    public function get_invoice_num_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return $this->get_invoice_num();
    }

    /**
     * get_invoice_date_by_id method is stand for get the value ofinvoice_date By id.
     *
     * @var date invoice_date
     */
    public function get_invoice_date_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return date("d-M-Y", strtotime($this->get_invoice_date()));
    }

    /**
     * get_invoice_net_amount_by_id method is stand for get the value
     * ofinvoice_net_amount By id.
     *
     * @var double invoice_net_amount
     */
    public function get_invoice_net_amount_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return (double) $this->get_invoice_net_amount();
    }

    /**
     * get_invoice_rebate_amount_by_id method is stand for get the value
     * ofinvoice_rebate_amount By id.
     *
     * @var double invoice_rebate_amount
     */
    public function get_invoice_rebate_amount_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return (double) $this->get_invoice_rebate_amount();
    }

    /**
     * get_invoice_disposal_amount_by_id method is stand for get the value
     * ofinvoice_disposal_amount By id.
     *
     * @var double invoice_disposal_amount
     */
    public function get_invoice_disposal_amount_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return (double) $this->get_invoice_disposal_amount();
    }

    /**
     * get_invoice_pay_mode_by_id method is stand for get the value ofinvoice_pay_mode
     * By id.
     *
     * @var varchar invoice_pay_mode
     */
    public function get_invoice_pay_mode_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return $this->get_invoice_pay_mode();
    }

    /**
     * get_invoice_is_paid_by_id method is stand for get the value ofinvoice_is_paid By
     * id.
     *
     * @var varchar invoice_is_paid
     */
    public function get_invoice_is_paid_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return $this->get_invoice_is_paid();
    }

    /**
     * get_invoice_remarks_by_id method is stand for get the value ofinvoice_remarks By
     * id.
     *
     * @var varchar invoice_remarks
     */
    public function get_invoice_remarks_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return $this->get_invoice_remarks();
    }

    /**
     * get_invoice_status_by_id method is stand for get the value ofinvoice_status By
     * id.
     *
     * @var varchar invoice_status
     */
    public function get_invoice_status_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return $this->get_invoice_status();
    }

    /**
     * get_invoice_updated_by_by_id method is stand for get the value
     * ofinvoice_updated_by By id.
     *
     * @var int invoice_updated_by
     */
    public function get_invoice_updated_by_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return (int) $this->get_invoice_updated_by();
    }

    /**
     * get_invoice_updated_date_by_id method is stand for get the value
     * ofinvoice_updated_date By id.
     *
     * @var timestamp invoice_updated_date
     */
    public function get_invoice_updated_date_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return date("d-M-Y (H:i:s)", strtotime($this->get_invoice_updated_date()));
    }

    /**
     * get_invoice_created_by_by_id method is stand for get the value
     * ofinvoice_created_by By id.
     *
     * @var int invoice_created_by
     */
    public function get_invoice_created_by_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return (int) $this->get_invoice_created_by();
    }

    /**
     * get_invoice_created_date_by_id method is stand for get the value
     * ofinvoice_created_date By id.
     *
     * @var timestamp invoice_created_date
     */
    public function get_invoice_created_date_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return date("d-M-Y (H:i:s)", strtotime($this->get_invoice_created_date()));
    }


}
