<?php

class Application_Model_AccountLogic extends Application_Model_Account
{
    
    public function convertToArchive($id)
    {
        $where = $this->select()->where('case_id = ?', $id)->where('invoice_status = ?', 'A');
        foreach($this->fetchAll($where) as $row) {
            $this->set_id($row->id);
            $this->fetch();
            $this->set_invoice_status('ARCHIVE');
            $user = new Application_Model_UserLogic(-1);
            $this->set_invoice_updated_by($user->getLoggedInUserId());
            $this->save();
        }
        $this->set_id(-1);
    }
    
    public function getActiveInvoiceByCase($id) {
        $where = $this->select()->where('case_id = ?', $id)->where('invoice_status = ?', 'A')->order('id desc')->limit(1);
        return $this->fetchRow($where);
    }
    
    public function setPaymentModeByCase($caseId, $mode) {
        $invoice = $this->getActiveInvoiceByCase($caseId);
        $this->set_id($invoice['id']);
        $this->fetch();
        $this->set_invoice_pay_mode($mode);
        if(in_array($mode, Application_Model_Cache_Config::getConfig('DEFAULT_ARCHIVE_PAYMENT_MODES'))) {
            $this->set_invoice_is_paid(true);
            $obj_case = new Application_Model_CaseLogic(-1);
            $obj_case->updateCaseStatus($caseId, Application_Model_CaseStatus::CASE_STATUS_ID_CLOSED);
        }
        $this->save();
        $this->set_id(-1);
    }
    
    public function setCasePaid($caseId) {
        $invoice = $this->getActiveInvoiceByCase($caseId);
        $this->set_id($invoice['id']);
        $this->fetch();
        $this->set_invoice_is_paid(true);
        $this->save();
        $this->set_id(-1);
    }
    
    public function getCaseLog($caseId)
    {
        return $this->select()->where('case_id = ?', $caseId)->where('invoice_status = ?', 'ARCHIVE')->order('id desc');
    }
}

