<?php

class Application_Model_SMSLog extends Zend_Db_Table_Abstract
{

    protected $_name = 'asit_sms_log';

    private $_id = null;

    private $_case_id = null;

    private $_sms_gateway_url = null;

    private $_sms_user = null;

    private $_sms_password = null;

    private $_sms_sender_id = null;

    private $_sms_mobile = null;

    private $_sms_message = null;

    private $_sms_response = null;

    private $_sms_created_by = null;

    private $_sms_created_date = null;

    /**
     * Constructor initialize primary key field value to set the set_id method. If
     * value = -1 then default object loaded.
     *
     * @var int id
     */
    public function __construct($id)
    {
        parent::__construct();
        $id = (int) $id;
        $this->set_id($id);
        if($id!=-1)
        {
          $this->fetch();
        }
    }

    /**
     * get id method is stand for get the value of id.
     *
     * @var int id
     */
    public function get_id()
    {
        return (int) $this->_id;
    }

    /**
     * set id method is stand for set the value of id.
     *
     * @var int id
     */
    public function set_id($value)
    {
        $this->_id = (int) $value;
    }

    /**
     * get case_id method is stand for get the value of case_id.
     *
     * @var int case_id
     */
    public function get_case_id()
    {
        return (int) $this->_case_id;
    }

    /**
     * set case_id method is stand for set the value of case_id.
     *
     * @var int case_id
     */
    public function set_case_id($value)
    {
        $this->_case_id = (int) $value;
    }

    /**
     * get sms_gateway_url method is stand for get the value of sms_gateway_url.
     *
     * @var varchar sms_gateway_url
     */
    public function get_sms_gateway_url()
    {
        return $this->_sms_gateway_url;
    }

    /**
     * set sms_gateway_url method is stand for set the value of sms_gateway_url.
     *
     * @var varchar sms_gateway_url
     */
    public function set_sms_gateway_url($value)
    {
        $this->_sms_gateway_url = $value;
    }

    /**
     * get sms_user method is stand for get the value of sms_user.
     *
     * @var varchar sms_user
     */
    public function get_sms_user()
    {
        return $this->_sms_user;
    }

    /**
     * set sms_user method is stand for set the value of sms_user.
     *
     * @var varchar sms_user
     */
    public function set_sms_user($value)
    {
        $this->_sms_user = $value;
    }

    /**
     * get sms_password method is stand for get the value of sms_password.
     *
     * @var varchar sms_password
     */
    public function get_sms_password()
    {
        return $this->_sms_password;
    }

    /**
     * set sms_password method is stand for set the value of sms_password.
     *
     * @var varchar sms_password
     */
    public function set_sms_password($value)
    {
        $this->_sms_password = $value;
    }

    /**
     * get sms_sender_id method is stand for get the value of sms_sender_id.
     *
     * @var varchar sms_sender_id
     */
    public function get_sms_sender_id()
    {
        return $this->_sms_sender_id;
    }

    /**
     * set sms_sender_id method is stand for set the value of sms_sender_id.
     *
     * @var varchar sms_sender_id
     */
    public function set_sms_sender_id($value)
    {
        $this->_sms_sender_id = $value;
    }

    /**
     * get sms_mobile method is stand for get the value of sms_mobile.
     *
     * @var varchar sms_mobile
     */
    public function get_sms_mobile()
    {
        return $this->_sms_mobile;
    }

    /**
     * set sms_mobile method is stand for set the value of sms_mobile.
     *
     * @var varchar sms_mobile
     */
    public function set_sms_mobile($value)
    {
        $this->_sms_mobile = $value;
    }

    /**
     * get sms_message method is stand for get the value of sms_message.
     *
     * @var varchar sms_message
     */
    public function get_sms_message()
    {
        return $this->_sms_message;
    }

    /**
     * set sms_message method is stand for set the value of sms_message.
     *
     * @var varchar sms_message
     */
    public function set_sms_message($value)
    {
        $this->_sms_message = $value;
    }

    /**
     * get sms_response method is stand for get the value of sms_response.
     *
     * @var varchar sms_response
     */
    public function get_sms_response()
    {
        return $this->_sms_response;
    }

    /**
     * set sms_response method is stand for set the value of sms_response.
     *
     * @var varchar sms_response
     */
    public function set_sms_response($value)
    {
        $this->_sms_response = $value;
    }

    /**
     * get sms_created_by method is stand for get the value of sms_created_by.
     *
     * @var int sms_created_by
     */
    public function get_sms_created_by()
    {
        return (int) $this->_sms_created_by;
    }

    /**
     * set sms_created_by method is stand for set the value of sms_created_by.
     *
     * @var int sms_created_by
     */
    public function set_sms_created_by($value)
    {
        $this->_sms_created_by = (int) $value;
    }

    /**
     * get sms_created_date method is stand for get the value of sms_created_date.
     *
     * @var timestamp sms_created_date
     */
    public function get_sms_created_date()
    {
        return date("d-M-Y (H:i:s)", strtotime($this->_sms_created_date));
    }

    /**
     * set sms_created_date method is stand for set the value of sms_created_date.
     *
     * @var timestamp sms_created_date
     */
    public function set_sms_created_date($value)
    {
        $this->_sms_created_date = date("Y-m-d H:i:s", strtotime($value));
    }

    /**
     * fetch data from asit_sms_log by set id thru constructor.
     *
     * @var int id
     * @var int case_id
     * @var varchar sms_gateway_url
     * @var varchar sms_user
     * @var varchar sms_password
     * @var varchar sms_sender_id
     * @var varchar sms_mobile
     * @var varchar sms_message
     * @var varchar sms_response
     * @var int sms_created_by
     * @var timestamp sms_created_date
     */
    public function fetch()
    {
        $select=$this->select()->where("id = ?",$this->get_id());
        $row=$this->fetchRow($select);
        if($row!=null){
          $this->set_id($row->id);
          $this->set_case_id($row->case_id);
          $this->set_sms_gateway_url($row->sms_gateway_url);
          $this->set_sms_user($row->sms_user);
          $this->set_sms_password($row->sms_password);
          $this->set_sms_sender_id($row->sms_sender_id);
          $this->set_sms_mobile($row->sms_mobile);
          $this->set_sms_message($row->sms_message);
          $this->set_sms_response($row->sms_response);
          $this->set_sms_created_by($row->sms_created_by);
          $this->set_sms_created_date($row->sms_created_date);
        }
    }

    /**
     * save method is stand for saving the data, if id = -1 then data insert as a new
     * record and if id is set via constructor then data should update
     *
     * @var int case_id
     * @var varchar sms_gateway_url
     * @var varchar sms_user
     * @var varchar sms_password
     * @var varchar sms_sender_id
     * @var varchar sms_mobile
     * @var varchar sms_message
     * @var varchar sms_response
     * @var int sms_created_by
     */
    public function save()
    {
        $data = array(
          "case_id" => $this->get_case_id(),
          "sms_gateway_url" => $this->get_sms_gateway_url(),
          "sms_user" => $this->get_sms_user(),
          "sms_password" => $this->get_sms_password(),
          "sms_sender_id" => $this->get_sms_sender_id(),
          "sms_mobile" => $this->get_sms_mobile(),
          "sms_message" => $this->get_sms_message(),
          "sms_response" => $this->get_sms_response(),
          "sms_created_by" => $this->get_sms_created_by());
        if($this->get_id()==-1)
        {
          return $this->insert($data);
        }
        else
        {
          $where = $this->getAdapter()->quoteInto("id = ?", $this->get_id());
          $this->update($data, $where);
        }
    }

    /**
     * remove method delete the record from asit_sms_log by id.
     *
     * @var int id
     */
    public function remove()
    {
        $where = $this->getAdapter()->quoteInto("id = ?", $this->get_id());
        $this->delete($where);
    }

    /**
     * fetch_list_select stand for selecting all records.
     */
    public function fetch_list_select()
    {
        $select = $this->select();
        return $select;
    }

    /**
     * get_case_id_by_id method is stand for get the value ofcase_id By id.
     *
     * @var int case_id
     */
    public function get_case_id_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return (int) $this->get_case_id();
    }

    /**
     * get_sms_gateway_url_by_id method is stand for get the value ofsms_gateway_url By
     * id.
     *
     * @var varchar sms_gateway_url
     */
    public function get_sms_gateway_url_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return $this->get_sms_gateway_url();
    }

    /**
     * get_sms_user_by_id method is stand for get the value ofsms_user By id.
     *
     * @var varchar sms_user
     */
    public function get_sms_user_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return $this->get_sms_user();
    }

    /**
     * get_sms_password_by_id method is stand for get the value ofsms_password By id.
     *
     * @var varchar sms_password
     */
    public function get_sms_password_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return $this->get_sms_password();
    }

    /**
     * get_sms_sender_id_by_id method is stand for get the value ofsms_sender_id By id.
     *
     * @var varchar sms_sender_id
     */
    public function get_sms_sender_id_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return $this->get_sms_sender_id();
    }

    /**
     * get_sms_mobile_by_id method is stand for get the value ofsms_mobile By id.
     *
     * @var varchar sms_mobile
     */
    public function get_sms_mobile_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return $this->get_sms_mobile();
    }

    /**
     * get_sms_message_by_id method is stand for get the value ofsms_message By id.
     *
     * @var varchar sms_message
     */
    public function get_sms_message_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return $this->get_sms_message();
    }

    /**
     * get_sms_response_by_id method is stand for get the value ofsms_response By id.
     *
     * @var varchar sms_response
     */
    public function get_sms_response_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return $this->get_sms_response();
    }

    /**
     * get_sms_created_by_by_id method is stand for get the value ofsms_created_by By
     * id.
     *
     * @var int sms_created_by
     */
    public function get_sms_created_by_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return (int) $this->get_sms_created_by();
    }

    /**
     * get_sms_created_date_by_id method is stand for get the value ofsms_created_date
     * By id.
     *
     * @var timestamp sms_created_date
     */
    public function get_sms_created_date_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return date("d-M-Y (H:i:s)", strtotime($this->get_sms_created_date()));
    }


}
