<?php

class Application_Model_Schedule extends Zend_Db_Table_Abstract
{

    protected $_name = 'asit_case_schedule';

    private $_id = null;

    private $_case_id = null;

    private $_sched_time = null;

    private $_sched_ac_type = null;

    private $_sched_ac_capacity = null;

    private $_sched_remarks = null;

    private $_sched_status = null;

    private $_sched_updated_by = null;

    private $_sched_updated_date = null;

    private $_sched_created_by = null;

    private $_sched_created_date = null;

    /**
     * Constructor initialize primary key field value to set the set_id method. If
     * value = -1 then default object loaded.
     *
     * @var int id
     */
    public function __construct($id)
    {
        parent::__construct();
        $id = (int) $id;
        $this->set_id($id);
        if($id!=-1)
        {
          $this->fetch();
        }
    }

    /**
     * get id method is stand for get the value of id.
     *
     * @var int id
     */
    public function get_id()
    {
        return (int) $this->_id;
    }

    /**
     * set id method is stand for set the value of id.
     *
     * @var int id
     */
    public function set_id($value)
    {
        $this->_id = (int) $value;
    }

    /**
     * get case_id method is stand for get the value of case_id.
     *
     * @var int case_id
     */
    public function get_case_id()
    {
        return (int) $this->_case_id;
    }

    /**
     * set case_id method is stand for set the value of case_id.
     *
     * @var int case_id
     */
    public function set_case_id($value)
    {
        $this->_case_id = (int) $value;
    }

    /**
     * get sched_time method is stand for get the value of sched_time.
     *
     * @var datetime sched_time
     */
    public function get_sched_time()
    {
        return $this->_sched_time;
    }

    /**
     * set sched_time method is stand for set the value of sched_time.
     *
     * @var datetime sched_time
     */
    public function set_sched_time($value)
    {
        $this->_sched_time = $value;
    }

    /**
     * get sched_ac_type method is stand for get the value of sched_ac_type.
     *
     * @var varchar sched_ac_type
     */
    public function get_sched_ac_type()
    {
        return $this->_sched_ac_type;
    }

    /**
     * set sched_ac_type method is stand for set the value of sched_ac_type.
     *
     * @var varchar sched_ac_type
     */
    public function set_sched_ac_type($value)
    {
        $this->_sched_ac_type = $value;
    }

    /**
     * get sched_ac_capacity method is stand for get the value of sched_ac_capacity.
     *
     * @var varchar sched_ac_capacity
     */
    public function get_sched_ac_capacity()
    {
        return $this->_sched_ac_capacity;
    }

    /**
     * set sched_ac_capacity method is stand for set the value of sched_ac_capacity.
     *
     * @var varchar sched_ac_capacity
     */
    public function set_sched_ac_capacity($value)
    {
        $this->_sched_ac_capacity = $value;
    }

    /**
     * get sched_remarks method is stand for get the value of sched_remarks.
     *
     * @var varchar sched_remarks
     */
    public function get_sched_remarks()
    {
        return $this->_sched_remarks;
    }

    /**
     * set sched_remarks method is stand for set the value of sched_remarks.
     *
     * @var varchar sched_remarks
     */
    public function set_sched_remarks($value)
    {
        $this->_sched_remarks = $value;
    }

    /**
     * get sched_status method is stand for get the value of sched_status.
     *
     * @var varchar sched_status
     */
    public function get_sched_status()
    {
        return $this->_sched_status;
    }

    /**
     * set sched_status method is stand for set the value of sched_status.
     *
     * @var varchar sched_status
     */
    public function set_sched_status($value)
    {
        $this->_sched_status = $value;
    }

    /**
     * get sched_updated_by method is stand for get the value of sched_updated_by.
     *
     * @var int sched_updated_by
     */
    public function get_sched_updated_by()
    {
        return (int) $this->_sched_updated_by;
    }

    /**
     * set sched_updated_by method is stand for set the value of sched_updated_by.
     *
     * @var int sched_updated_by
     */
    public function set_sched_updated_by($value)
    {
        $this->_sched_updated_by = (int) $value;
    }

    /**
     * get sched_updated_date method is stand for get the value of sched_updated_date.
     *
     * @var timestamp sched_updated_date
     */
    public function get_sched_updated_date()
    {
        return date("d-M-Y (H:i:s)", strtotime($this->_sched_updated_date));
    }

    /**
     * set sched_updated_date method is stand for set the value of sched_updated_date.
     *
     * @var timestamp sched_updated_date
     */
    public function set_sched_updated_date($value)
    {
        $this->_sched_updated_date = date("Y-m-d H:i:s", strtotime($value));
    }

    /**
     * get sched_created_by method is stand for get the value of sched_created_by.
     *
     * @var int sched_created_by
     */
    public function get_sched_created_by()
    {
        return (int) $this->_sched_created_by;
    }

    /**
     * set sched_created_by method is stand for set the value of sched_created_by.
     *
     * @var int sched_created_by
     */
    public function set_sched_created_by($value)
    {
        $this->_sched_created_by = (int) $value;
    }

    /**
     * get sched_created_date method is stand for get the value of sched_created_date.
     *
     * @var timestamp sched_created_date
     */
    public function get_sched_created_date()
    {
        return date("d-M-Y (H:i:s)", strtotime($this->_sched_created_date));
    }

    /**
     * set sched_created_date method is stand for set the value of sched_created_date.
     *
     * @var timestamp sched_created_date
     */
    public function set_sched_created_date($value)
    {
        $this->_sched_created_date = date("Y-m-d H:i:s", strtotime($value));
    }

    /**
     * fetch data from asit_case_schedule by set id thru constructor.
     *
     * @var int id
     * @var int case_id
     * @var datetime sched_time
     * @var varchar sched_ac_type
     * @var varchar sched_ac_capacity
     * @var varchar sched_remarks
     * @var varchar sched_status
     * @var int sched_updated_by
     * @var timestamp sched_updated_date
     * @var int sched_created_by
     * @var timestamp sched_created_date
     */
    public function fetch()
    {
        $select=$this->select()->where("id = ?",$this->get_id());
        $row=$this->fetchRow($select);
        if($row!=null){
          $this->set_id($row->id);
          $this->set_case_id($row->case_id);
          $this->set_sched_time($row->sched_time);
          $this->set_sched_ac_type($row->sched_ac_type);
          $this->set_sched_ac_capacity($row->sched_ac_capacity);
          $this->set_sched_remarks($row->sched_remarks);
          $this->set_sched_status($row->sched_status);
          $this->set_sched_updated_by($row->sched_updated_by);
          $this->set_sched_updated_date($row->sched_updated_date);
          $this->set_sched_created_by($row->sched_created_by);
          $this->set_sched_created_date($row->sched_created_date);
        }
    }

    /**
     * save method is stand for saving the data, if id = -1 then data insert as a new
     * record and if id is set via constructor then data should update
     *
     * @var int case_id
     * @var datetime sched_time
     * @var varchar sched_ac_type
     * @var varchar sched_ac_capacity
     * @var varchar sched_remarks
     * @var varchar sched_status
     * @var int sched_updated_by
     * @var int sched_created_by
     */
    public function save()
    {
        $data = array(
          "case_id" => $this->get_case_id(),
          "sched_time" => $this->get_sched_time(),
          "sched_ac_type" => $this->get_sched_ac_type(),
          "sched_ac_capacity" => $this->get_sched_ac_capacity(),
          "sched_remarks" => $this->get_sched_remarks(),
          "sched_status" => $this->get_sched_status(),
          "sched_updated_by" => $this->get_sched_updated_by(),
          "sched_created_by" => $this->get_sched_created_by());
        if($this->get_id()==-1)
        {
          return $this->insert($data);
        }
        else
        {
          $where = $this->getAdapter()->quoteInto("id = ?", $this->get_id());
          $this->update($data, $where);
        }
    }

    /**
     * remove method delete the record from asit_case_schedule by id.
     *
     * @var int id
     */
    public function remove()
    {
        $where = $this->getAdapter()->quoteInto("id = ?", $this->get_id());
        $this->delete($where);
    }

    /**
     * fetch_list_select stand for selecting all records.
     */
    public function fetch_list_select()
    {
        $select = $this->select();
        return $select;
    }

    /**
     * get_case_id_by_id method is stand for get the value ofcase_id By id.
     *
     * @var int case_id
     */
    public function get_case_id_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return (int) $this->get_case_id();
    }

    /**
     * get_sched_time_by_id method is stand for get the value ofsched_time By id.
     *
     * @var datetime sched_time
     */
    public function get_sched_time_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return $this->get_sched_time();
    }

    /**
     * get_sched_ac_type_by_id method is stand for get the value ofsched_ac_type By id.
     *
     * @var varchar sched_ac_type
     */
    public function get_sched_ac_type_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return $this->get_sched_ac_type();
    }

    /**
     * get_sched_ac_capacity_by_id method is stand for get the value
     * ofsched_ac_capacity By id.
     *
     * @var varchar sched_ac_capacity
     */
    public function get_sched_ac_capacity_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return $this->get_sched_ac_capacity();
    }

    /**
     * get_sched_remarks_by_id method is stand for get the value ofsched_remarks By id.
     *
     * @var varchar sched_remarks
     */
    public function get_sched_remarks_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return $this->get_sched_remarks();
    }

    /**
     * get_sched_status_by_id method is stand for get the value ofsched_status By id.
     *
     * @var varchar sched_status
     */
    public function get_sched_status_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return $this->get_sched_status();
    }

    /**
     * get_sched_updated_by_by_id method is stand for get the value ofsched_updated_by
     * By id.
     *
     * @var int sched_updated_by
     */
    public function get_sched_updated_by_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return (int) $this->get_sched_updated_by();
    }

    /**
     * get_sched_updated_date_by_id method is stand for get the value
     * ofsched_updated_date By id.
     *
     * @var timestamp sched_updated_date
     */
    public function get_sched_updated_date_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return date("d-M-Y (H:i:s)", strtotime($this->get_sched_updated_date()));
    }

    /**
     * get_sched_created_by_by_id method is stand for get the value ofsched_created_by
     * By id.
     *
     * @var int sched_created_by
     */
    public function get_sched_created_by_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return (int) $this->get_sched_created_by();
    }

    /**
     * get_sched_created_date_by_id method is stand for get the value
     * ofsched_created_date By id.
     *
     * @var timestamp sched_created_date
     */
    public function get_sched_created_date_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return date("d-M-Y (H:i:s)", strtotime($this->get_sched_created_date()));
    }


}