<?php

class Dynasty_AcController extends Zend_Controller_Action
{

    public function init()
    {
        /* Initialize action controller here */
        $this->_helper->layout()->setLayout('admin');
    }

    public function indexAction()
    {
        // action body
        if(Application_Model_RolePermissionLogic::isPermitted("AC:Master")) {
            
        }else {
            throw new Zend_Controller_Action_Exception(Application_Model_Cache_Config::getConfig('AUTHENTICATION_ERROR'), 404);
        }
    }
    
    public function jsonAction()
    {
        $this->_helper->layout()->disableLayout();
        $obj_ac = new Application_Model_ACLogic(-1);
        echo $obj_ac->fetchDataTableSelect();
    }

    public function addAction()
    {
        if(Application_Model_RolePermissionLogic::isPermitted("AC:Add")) {
            $obj_form = new Application_Form_AC();
            $this->view->form = $obj_form;
            $obj_asitac = new Application_Model_ACLogic(-1);
            if($this->getRequest()->isPost()){
               $data=$this->getRequest()->getPost();
               if($obj_form->isValid($data)){
                 $obj_asitac->set_ac_company($obj_form->ac_company->getValue());
                 $obj_asitac->set_ac_model($obj_form->ac_model->getValue());
                 $obj_asitac->set_ac_capacity($obj_form->ac_capacity->getValue());
                 $obj_asitac->set_ac_mfg_year($obj_form->ac_mfg_year->getValue());
                 $obj_asitac->set_ac_status('A');
                 $obj_user = new Application_Model_UserLogic(-1);
                 $obj_asitac->set_ac_updated_by($obj_user->getLoggedInUserId());
                 $obj_asitac->set_ac_created_by($obj_user->getLoggedInUserId());
                 $obj_asitac->save();

                 $sess = new Zend_Session_Namespace("msg");
                 $sess->msg = "AC Added Successfully!!!";
                 $this->_redirect("dynasty/ac/index");
               }
            }
        }else {
            throw new Zend_Controller_Action_Exception(Application_Model_Cache_Config::getConfig('AUTHENTICATION_ERROR'), 404);
        }
    }

    public function editAction()
    {
        if(Application_Model_RolePermissionLogic::isPermitted("AC:Edit")) {
            $enc = new Application_Model_Util_Encrypt();
            $id = $enc->showHiddenContent($this->_getParam("id"));
            $obj_form = new Application_Form_AC();
            $obj_asitac = new Application_Model_ACLogic($id);
            $obj_form->ac_company->setValue($obj_asitac->get_ac_company());
            $obj_form->ac_model->setValue($obj_asitac->get_ac_model());
            $obj_form->ac_capacity->setValue($obj_asitac->get_ac_capacity());
            $obj_form->ac_mfg_year->setValue($obj_asitac->get_ac_mfg_year());
            $this->view->form = $obj_form;
            if($this->getRequest()->isPost()){
                $data=$this->getRequest()->getPost();
                if($obj_form->isValid($data)){
                    $obj_asitac->set_ac_company($obj_form->ac_company->getValue());
                    $obj_asitac->set_ac_model($obj_form->ac_model->getValue());
                    $obj_asitac->set_ac_capacity($obj_form->ac_capacity->getValue());
                    $obj_asitac->set_ac_mfg_year($obj_form->ac_mfg_year->getValue());
                    $obj_user = new Application_Model_UserLogic(-1);
                    $obj_asitac->set_ac_updated_by($obj_user->getLoggedInUserId());
                    $obj_asitac->save();

                    $sess = new Zend_Session_Namespace("msg");
                    $sess->msg = "AC Updated Successfully!!!";
                    $this->_redirect("dynasty/ac/index");
                }
            }
        }else {
            throw new Zend_Controller_Action_Exception(Application_Model_Cache_Config::getConfig('AUTHENTICATION_ERROR'), 404);
        }
    }
    
    public function deleteAction()
    {
        if(Application_Model_RolePermissionLogic::isPermitted("AC:Delete")) {
            $enc = new Application_Model_Util_Encrypt();
            $id = $enc->showHiddenContent($this->_getParam('id'));
            
            $obj_ac = new Application_Model_ACLogic($id);
            $obj_ac->set_ac_status('D');
            $obj_user = new Application_Model_UserLogic(-1);
            $obj_ac->set_ac_updated_by($obj_user->getLoggedInUserId());
            $obj_ac->save();
            
            $sess = new Zend_Session_Namespace("msg");
            $sess->msg = "AC Removed Successfully!!!";
            $this->_redirect("dynasty/ac/index");
        }else {
            throw new Zend_Controller_Action_Exception(Application_Model_Cache_Config::getConfig('AUTHENTICATION_ERROR'), 404);
        }
    }
    
}

