<?php

class Dynasty_CalendarController extends Zend_Controller_Action
{

    public function init()
    {
        /* Initialize action controller here */
        $this->_helper->layout()->setLayout('admin');
    }

    public function indexAction()
    {
        
    }
    
    public function eventsAction()
    {
        if(Application_Model_RolePermissionLogic::isPermitted("Dashboard")) {
            $this->_helper->layout()->disableLayout();
            $start = date('Y-m-d', $this->_getParam('start')); 
            $end = date('Y-m-d', $this->_getParam('end')); 
            
            $obj_case = new Application_Model_CaseLogic(-1);
            $schedule_case = $obj_case->getScheduledCase($start, $end);
            $install_case = $obj_case->getInstalledCase($start, $end);
            $invoice_case = $obj_case->getInvoicedCase($start, $end);
            $closed_case = $obj_case->getInstalledCase($start, $end);

            $date = date('Y-m-d');
            $baseUrl = new Zend_View_Helper_BaseUrl();
            $enc = new Application_Model_Util_Encrypt();
            
            $events = array();
            
            foreach($schedule_case as $evt) {
                $url = $baseUrl->baseUrl('dynasty/case/view/id/'.$enc->hideContent($evt->id));
                $className = (($evt->sched_time > $date) ? 'fc-event-green' : 'fc-event-red');
                
                $final = array();
                $final['id'] = $evt->id;
                $final['title'] = 'Scheduled '.$evt->case_name.' Case';
                $final['start'] = $evt->sched_time;
                $final['allDay'] = true;
                $final['url'] = $url;
                $final['className'] = $className;
                array_push($events, $final);
            }
            
            foreach($install_case as $evt) {
                $url = $baseUrl->baseUrl('dynasty/case/view/id/'.$enc->hideContent($evt->id));
                $className = (($evt->install_date > $date) ? 'fc-event-green' : 'fc-event-red');
                
                $final = array();
                $final['id'] = $evt->id;
                $final['title'] = 'Installed '.$evt->case_name.' Case';
                $final['start'] = $evt->install_date;
                $final['allDay'] = true;
                $final['url'] = $url;
                $final['className'] = $className;
                array_push($events, $final);
            }
            
            foreach($invoice_case as $evt) {
                $url = $baseUrl->baseUrl('dynasty/case/view/id/'.$enc->hideContent($evt->id));
                $className = 'fc-event-yellow';
                
                $final = array();
                $final['id'] = $evt->id;
                $final['title'] = 'Invoices '.$evt->case_name.' Case';
                $final['start'] = $evt->invoice_date;
                $final['allDay'] = true;
                $final['url'] = $url;
                $final['className'] = $className;
                array_push($events, $final);
            }
            
            foreach($closed_case as $evt) {
                $url = $baseUrl->baseUrl('dynasty/case/view/id/'.$enc->hideContent($evt->id));
                $className = 'fc-event-grey';
                
                $final = array();
                $final['id'] = $evt->id;
                $final['title'] = 'Closed '.$evt->case_name.' Case';
                $final['start'] = $evt->case_status_date;
                $final['allDay'] = true;
                $final['url'] = $url;
                $final['className'] = $className;
                array_push($events, $final);
            }

            //Zend_Debug::dump($events);
            echo json_encode($events);
        }else {
            throw new Zend_Controller_Action_Exception(Application_Model_Cache_Config::getConfig('AUTHENTICATION_ERROR'), 404);
        } 
        
    }


}

