<?php

class Dynasty_CaseController extends Zend_Controller_Action
{

    public function init()
    {
        /* Initialize action controller here */
        $this->_helper->layout()->setLayout('admin');
    }

    public function indexAction()
    {
        // action body
        if(Application_Model_RolePermissionLogic::isPermitted("Case:Master")) {
            $this->view->key = $key = $this->_getParam('key');
        }else {
            throw new Zend_Controller_Action_Exception(Application_Model_Cache_Config::getConfig('AUTHENTICATION_ERROR'), 404);
        }
    }
    
    public function jsonAction()
    {
        $this->_helper->layout()->disableLayout();
        $key = $this->_getParam('key');
        $obj_case = new Application_Model_CaseLogic(-1);
        echo $obj_case->fetchDataTableSelect($key);
    }

    public function addAction()
    {
        if(Application_Model_RolePermissionLogic::isPermitted("Case:Add")) {
            $obj_form = new Application_Form_Case();
            $this->view->form = $obj_form;
            $obj_asitcase = new Application_Model_CaseLogic(-1);
            if($this->getRequest()->isPost()){
               $data=$this->getRequest()->getPost();
               if($obj_form->isValid($data)){
                 if(!$obj_asitcase->isCaseNumExist($obj_form->case_num->getValue())) {
                    $user = new Application_Model_UserLogic(-1);
                    $obj_asitcase->set_case_id($obj_asitcase->generateCaseId());
                    $obj_asitcase->set_case_num($obj_form->case_num->getValue());
                    $obj_asitcase->set_case_account($obj_form->case_account->getValue());
                    $obj_asitcase->set_case_name($obj_form->case_name->getValue());
                    $obj_asitcase->set_case_address($obj_form->case_address->getValue());
                    $obj_asitcase->set_case_mobile($obj_form->case_mobile->getValue());
                    $obj_asitcase->set_case_mobile_other($obj_form->case_mobile_other->getValue());
                    $obj_asitcase->set_case_register_by($obj_form->case_register_by->getValue());
                    $obj_asitcase->set_case_date($obj_form->case_date->getValue());
                    $obj_asitcase->set_case_short_code($obj_form->case_short_code->getValue());
                    $obj_asitcase->set_case_segment('');//$obj_form->case_segment->getValue());
                    $obj_asitcase->set_case_conn_type('');//$obj_form->case_conn_type->getValue());
                    $obj_asitcase->set_case_rate_cat('');//$obj_form->case_rate_cat->getValue());
                    $obj_asitcase->set_case_status(Application_Model_CaseStatus::CASE_STATUS_ID_INITIATED);
                    $obj_asitcase->set_case_status_date(date('Y-m-d H:i:s'));
                    $obj_asitcase->set_case_updated_by($user->getLoggedInUserId());
                    $obj_asitcase->set_case_created_by($user->getLoggedInUserId());
                    $obj_asitcase->save();

                    $caseId = $obj_asitcase->getAdapter()->lastInsertId();

                    Application_Model_Util_SMS::sendCaseRegistrationInfo($caseId, $obj_form->case_mobile->getValue());

                    $sess = new Zend_Session_Namespace("msg");
                    $sess->msg = "Case Registered Successfully!!!";
                    $this->_redirect("dynasty/case/index");
                 }else {
                    $sess = new Zend_Session_Namespace("msg");
                    $sess->error = "Sorry, Notification Number already exist!!!";
                    $this->_redirect("dynasty/case/index");
                 }
               }
            }
        }else {
            throw new Zend_Controller_Action_Exception(Application_Model_Cache_Config::getConfig('AUTHENTICATION_ERROR'), 404);
        }
    }

    public function editAction()
    {
        if(Application_Model_RolePermissionLogic::isPermitted("Case:Edit")) {
            $enc = new Application_Model_Util_Encrypt();
            $id = $enc->showHiddenContent($this->_getParam("id"));
            $obj_form = new Application_Form_Case();
            $obj_asitcase = new Application_Model_CaseLogic($id);
            $obj_form->case_num->setValue($obj_asitcase->get_case_num());
            $obj_form->case_account->setValue($obj_asitcase->get_case_account());
            $obj_form->case_name->setValue($obj_asitcase->get_case_name());
            $obj_form->case_address->setValue($obj_asitcase->get_case_address());
            $obj_form->case_mobile->setValue($obj_asitcase->get_case_mobile());
            $obj_form->case_mobile_other->setValue($obj_asitcase->get_case_mobile_other());
            $obj_form->case_register_by->setValue($obj_asitcase->get_case_register_by());
            $obj_form->case_date->setValue($obj_asitcase->get_case_date());
            $obj_form->case_short_code->setValue($obj_asitcase->get_case_short_code());
            //$obj_form->case_segment->setValue($obj_asitcase->get_case_segment());
            //$obj_form->case_conn_type->setValue($obj_asitcase->get_case_conn_type());
            //$obj_form->case_rate_cat->setValue($obj_asitcase->get_case_rate_cat());
            $this->view->form = $obj_form;
            if($this->getRequest()->isPost()){
              $data=$this->getRequest()->getPost();
              if($obj_form->isValid($data)){
                 $user = new Application_Model_UserLogic(-1); 
                 $obj_asitcase->set_case_num($obj_form->case_num->getValue());
                 $obj_asitcase->set_case_account($obj_form->case_account->getValue());
                 $obj_asitcase->set_case_name($obj_form->case_name->getValue());
                 $obj_asitcase->set_case_address($obj_form->case_address->getValue());
                 $obj_asitcase->set_case_mobile($obj_form->case_mobile->getValue());
                 $obj_asitcase->set_case_mobile_other($obj_form->case_mobile_other->getValue());
                 $obj_asitcase->set_case_register_by($obj_form->case_register_by->getValue());
                 $obj_asitcase->set_case_date($obj_form->case_date->getValue());
                 $obj_asitcase->set_case_short_code($obj_form->case_short_code->getValue());
                 //$obj_asitcase->set_case_segment($obj_form->case_segment->getValue());
                 //$obj_asitcase->set_case_conn_type($obj_form->case_conn_type->getValue());
                 //$obj_asitcase->set_case_rate_cat($obj_form->case_rate_cat->getValue());
                 $obj_asitcase->set_case_updated_by($user->getLoggedInUserId());
                 $obj_asitcase->save();

                 $sess = new Zend_Session_Namespace("msg");
                 $sess->msg = "Case Updated Successfully!!!";
                 $this->_redirect("dynasty/case/index");
              }
            }
        }else {
            throw new Zend_Controller_Action_Exception(Application_Model_Cache_Config::getConfig('AUTHENTICATION_ERROR'), 404);
        }
    }
    
    public function deleteAction()
    {
        if(Application_Model_RolePermissionLogic::isPermitted("Case:Delete")) {
            $enc = new Application_Model_Util_Encrypt();
            $id = $enc->showHiddenContent($this->_getParam('id'));
            
            $obj_case = new Application_Model_CaseLogic($id);
            $obj_case->set_case_status('D');
            $obj_case->save();
            
            $sess = new Zend_Session_Namespace("msg");
            $sess->msg = "Case Removed Successfully!!!";
            $this->_redirect("dynasty/case/index");
        }else {
            throw new Zend_Controller_Action_Exception(Application_Model_Cache_Config::getConfig('AUTHENTICATION_ERROR'), 404);
        }
    }
    
    public function importAction()
    {
        if(Application_Model_RolePermissionLogic::isPermitted("Case:Import")) {
            $obj_form = new Application_Form_CaseImport();
            $this->view->form = $obj_form;
            if($this->getRequest()->isPost()) {
                $data = $this->getRequest()->getPost();
                if($obj_form->isValid($data)) {
                    $row = 1;
                    $obj_case = new Application_Model_CaseLogic(-1);
                    $user = new Application_Model_UserLogic(-1);
                    $msg = '';
                    $file = Application_Model_Cache_Config::getConfig('UPLOAD_FOLDER_NAME').'/'.Application_Model_Cache_Config::getConfig('TEMP_FOLDER').'/'.$obj_form->case_file->getValue();
                    if (($handle = fopen($file, "r")) !== FALSE) {
                        while (($data = fgetcsv($handle, 5000, ",")) !== FALSE) {
                            $num = count($data);
                            $caseNum = (int)($data[0]);
                            if($caseNum > 0) {
                                if(!$obj_case->isCaseNumExist($caseNum)) {
                                    $obj_case->set_case_id($obj_case->generateCaseId());
                                    $obj_case->set_case_num($caseNum);
                                    $obj_case->set_case_account(trim($data[1]));
                                    $obj_case->set_case_name(trim($data[2]));//$data[10]);
                                    $obj_case->set_case_address(trim($data[3]));//$data[11]);
                                    $obj_case->set_case_mobile(trim($data[6]));//$data[4]);
                                    $obj_case->set_case_mobile_other(trim($data[7]));//$data[5]);
                                    $obj_case->set_case_register_by(trim($data[4]));//$data[2]);
                                    $obj_case->set_case_date(date(Application_Model_Cache_Config::getConfig('DEFAULT_DB_FORMAT'), strtotime(trim($data[5]))));//$data[3])));
                                    $obj_case->set_case_short_code(trim($data[8]));//$data[6]);
                                    $obj_case->set_case_segment('');//$data[7]);
                                    $obj_case->set_case_conn_type('');//$data[8]);
                                    $obj_case->set_case_rate_cat('');//$data[9]);
                                    $obj_case->set_case_status(Application_Model_CaseStatus::CASE_STATUS_ID_INITIATED);
                                    $obj_case->set_case_status_date(date('Y-m-d H:i:s'));
                                    $obj_case->set_case_updated_by($user->getLoggedInUserId());
                                    $obj_case->set_case_created_by($user->getLoggedInUserId());
                                    $obj_case->save();
                                    
                                    $caseId = $obj_case->getAdapter()->lastInsertId();
                                    
                                    Application_Model_Util_SMS::sendCaseRegistrationInfo($caseId, $obj_case->get_case_mobile());
                                    
                                }else {
                                    $msg .= 'Case Number <b>'.$data[0].'</b> is already exist.<br />';
                                }
                            }else {
                                $msg .= 'Case Number <b>'.$data[0].'</b> is not a valid number.<br />';
                            }
//                            for ($c=0; $c < $num; $c++) {
//                                echo $data[$c] . "<br />\n";
//                            }
                            $row++;
                        }
                        fclose($handle);
                    }
                    $sess = new Zend_Session_Namespace("msg");
                    $sess->msg = "Case Registered Successfully!!!";
                    $sess->error = $msg;
                    $this->_redirect("dynasty/case/index");
                }
            }
        }else {
            throw new Zend_Controller_Action_Exception(Application_Model_Cache_Config::getConfig('AUTHENTICATION_ERROR'), 404);
        }
    }

    public function viewAction()
    {
        if(Application_Model_RolePermissionLogic::isPermitted("Case:Home")) {
            $enc = new Application_Model_Util_Encrypt();
            $this->view->caseId = $caseId = $this->_getParam("id");
            $id = $enc->showHiddenContent($caseId);
            $this->view->case = $obj_case = new Application_Model_View_Case($id);
        }else {
            throw new Zend_Controller_Action_Exception(Application_Model_Cache_Config::getConfig('AUTHENTICATION_ERROR'), 404);
        }
    }
    
    public function searchAction()
    {
        if(Application_Model_RolePermissionLogic::isPermitted("Case:Home")) {
            
            if($this->getRequest()->isPost()) {
                $data = $this->getRequest()->getPost();
                
                $report = new Application_Model_Report(-1);
                $filter = array();
                $filter['case_id'] = (!empty($data['caseNum'])) ? $data['caseNum'] : null;
                $filter['case_num'] = (!empty($data['caseNum'])) ? $data['caseNum'] : null;
                $filter['case_account'] = (!empty($data['caseAccount'])) ? $data['caseAccount'] : null;
                $filter['case_mobile'] = (!empty($data['mobile'])) ? $data['mobile'] : null;
                $filter['case_created_date_from'] = (!empty($data['registerDateFrom'])) ? date('Y-m-d', strtotime($data['registerDateFrom'])) : null;
                $filter['case_created_date_to'] = (!empty($data['registerDateTo'])) ? date('Y-m-d', strtotime($data['registerDateTo'])) : null;
                $filter['case_created_date'] = ($filter['case_created_date_from'] != null && $filter['case_created_date_to'] != null) ? true : null;
                $filter['case_status'] = (!empty($data['caseStatus'])) ? $data['caseStatus'] : null;
                $filter['case_date_from'] = (!empty($data['createdDateFrom'])) ? date('Y-m-d', strtotime($data['createdDateFrom'])) : null;
                $filter['case_date_to'] = (!empty($data['createdDateTo'])) ? date('Y-m-d', strtotime($data['createdDateTo'])) : null;
                $filter['case_date'] = ($filter['case_date_from'] != null && $filter['case_date_to'] != null) ? true : null;
                $filter['sched_time_from'] = (!empty($data['scheduleDateFrom'])) ? date('Y-m-d', strtotime($data['scheduleDateFrom'])) : null;
                $filter['sched_time_to'] = (!empty($data['scheduleDateTo'])) ? date('Y-m-d', strtotime($data['scheduleDateTo'])) : null;
                $filter['sched_time'] = ($filter['sched_time_from'] != null && $filter['sched_time_to'] != null) ? true : null;
                $filter['install_unique_id'] = (!empty($data['installUniqueID'])) ? $data['installUniqueID'] : null;
                $filter['install_ac_make'] = (!empty($data['installACMake'])) ? $data['installACMake'] : null;
                $filter['install_ac_model'] = (!empty($data['installACModel'])) ? $data['installACModel'] : null;
                $filter['install_ac_capacity'] = (!empty($data['installACCapacity'])) ? $data['installACCapacity'] : null;
                $filter['sched_ac_type'] = (!empty($data['schedACType'])) ? $data['schedACType'] : null;
                $filter['sched_ac_capacity'] = (!empty($data['schedACCapacity'])) ? $data['schedACCapacity'] : null;
                $filter['install_date_from'] = (!empty($data['installDateFrom'])) ? date('Y-m-d', strtotime($data['installDateFrom'])) : null;
                $filter['install_date_to'] = (!empty($data['installDateTo'])) ? date('Y-m-d', strtotime($data['installDateTo'])) : null;
                $filter['install_date'] = ($filter['install_date_from'] != null && $filter['install_date_to'] != null) ? true : null;
                $filter['invoice_num'] = (!empty($data['invoiceNum'])) ? $data['invoiceNum'] : null;
                $filter['invoice_date_from'] = (!empty($data['invoiceDateFrom'])) ? date('Y-m-d', strtotime($data['invoiceDateFrom'])) : null;
                $filter['invoice_date_to'] = (!empty($data['invoiceDateTo'])) ? date('Y-m-d', strtotime($data['invoiceDateTo'])) : null;
                $filter['invoice_date'] = ($filter['invoice_date_from'] != null && $filter['invoice_date_to'] != null) ? true : null;
                $filter['case_status_date_from'] = (!empty($data['closeDateFrom'])) ? date('Y-m-d', strtotime($data['closeDateFrom'])) : null;
                $filter['case_status_date_to'] = (!empty($data['closeDateTo'])) ? date('Y-m-d', strtotime($data['closeDateTo'])) : null;
                $filter['case_status_date'] = ($filter['case_status_date_from'] != null && $filter['case_status_date_to'] != null) ? true : null;
                $query = (!empty($data['query'])) ? $data['query'] : null;
                $output = (!empty($data['opform'])) ? $data['opform'] : null;
                //Zend_Debug::dump($filter);
                $this->view->isResultShow = true;
                if(!array_filter($filter) && $query == null) {
                    $this->view->results = null;
                }else {
                    if($output == 'D') {
                        $this->_helper->layout()->disableLayout();
                        $this->view->results = null;
                        $this->view->renderCSV = true;
                        $report->exportToCSV($filter, $query);
                    }else {
                        $this->view->results = $results = $report->getFilterResults($filter, $query);
                    }
                }
            }else {
                $this->view->isResultShow = false;
                $this->view->results = null;
            }
            
        }else {
            
        }
    }

}

