<?php

class Dynasty_EntryController extends Zend_Controller_Action
{

    public function init()
    {
        /* Initialize action controller here */
        $this->_helper->layout()->setLayout('admin');
    }

    public function indexAction()
    {
        if(Application_Model_RolePermissionLogic::isPermitted("Dashboard")) {
            
        }else {
            throw new Zend_Controller_Action_Exception(Application_Model_Cache_Config::getConfig('AUTHENTICATION_ERROR'), 404);
        }
    }
    
    public function schedAction()
    {
        if(Application_Model_RolePermissionLogic::isPermitted("Case:Schedule:Add") || Application_Model_RolePermissionLogic::isPermitted("Case:Schedule:Edit")) {
            $enc = new Application_Model_Util_Encrypt();
            $obj_form = new Application_Form_Schedule();
            if($this->_getParam("id") != null) {
                $id = $enc->showHiddenContent($this->_getParam("id"));
                $obj_asitcaseschedule = new Application_Model_ScheduleLogic($id);
                $obj_form->case_id->setValue($obj_asitcaseschedule->get_case_id());
                $obj_form->sched_date->setValue(date('d-M-Y', strtotime($obj_asitcaseschedule->get_sched_time())));
                $obj_form->sched_time->setValue(date('h:i A', strtotime($obj_asitcaseschedule->get_sched_time())));
                $obj_form->sched_ac_type->setValue($obj_asitcaseschedule->get_sched_ac_type());
                $obj_form->sched_ac_capacity->setValue($obj_asitcaseschedule->get_sched_ac_capacity());
                $obj_form->sched_remarks->setValue($obj_asitcaseschedule->get_sched_remarks());
                $this->view->form = $obj_form;
                $this->view->caseId = $enc->hideContent($obj_asitcaseschedule->get_case_id());
            }else if($this->_getParam("caseId") != null) {
                $this->view->caseId = $this->_getParam("caseId");
                $caseId = $enc->showHiddenContent($this->_getParam("caseId"));
                $obj_form->case_id->setValue($caseId);
                $this->view->form = $obj_form;
            }
            if($this->getRequest()->isPost()){
                $data=$this->getRequest()->getPost();
                if($obj_form->isValid($data)){
                    $obj_asitcaseschedule = new Application_Model_ScheduleLogic(-1);
                    $obj_asitcaseschedule->convertToArchive($obj_form->case_id->getValue());
                    $obj_asitcaseschedule->set_case_id($obj_form->case_id->getValue());
                    $obj_asitcaseschedule->set_sched_time(date(Application_Model_Cache_Config::getConfig('DEFAULT_DB_FORMAT'), strtotime($obj_form->sched_date->getValue().' '.$obj_form->sched_time->getValue())));
                    $obj_asitcaseschedule->set_sched_ac_type($obj_form->sched_ac_type->getValue());
                    $obj_asitcaseschedule->set_sched_ac_capacity($obj_form->sched_ac_capacity->getValue());
                    $obj_asitcaseschedule->set_sched_remarks($obj_form->sched_remarks->getValue());
                    $obj_asitcaseschedule->set_sched_status('A');
                    $user = new Application_Model_UserLogic(-1);
                    $obj_asitcaseschedule->set_sched_updated_by($user->getLoggedInUserId());
                    $obj_asitcaseschedule->set_sched_created_by($user->getLoggedInUserId());
                    $obj_asitcaseschedule->save();
                    
                    $obj_case = new Application_Model_CaseLogic(-1);
                    $obj_case->updateCaseStatus($caseId, Application_Model_CaseStatus::CASE_STATUS_ID_SCHEDULED);

                    $sess = new Zend_Session_Namespace("msg");
                    $sess->msg = "Case has been scheduled successfully!!!";
                    $this->_redirect("dynasty/case/view/id/".$enc->hideContent($obj_form->case_id->getValue()));
                }
            }
        }else {
            throw new Zend_Controller_Action_Exception(Application_Model_Cache_Config::getConfig('AUTHENTICATION_ERROR'), 404);
        }
    }
    
    public function installAction()
    {
        if(Application_Model_RolePermissionLogic::isPermitted("Case:Install:Add") || Application_Model_RolePermissionLogic::isPermitted("Case:Install:Edit")) {
            $enc = new Application_Model_Util_Encrypt();
            $obj_form = new Application_Form_Install();
            if($this->_getParam("id") != null) {
                $id = $enc->showHiddenContent($this->_getParam("id"));
                $obj_asitcaseinstall = new Application_Model_InstallLogic($id);
                $obj_form->case_id->setValue($obj_asitcaseinstall->get_case_id());
                $obj_form->install_ac_make->setValue($obj_asitcaseinstall->get_install_ac_make());
                $obj_form->install_ac_model->setValue($obj_asitcaseinstall->get_install_ac_model());
                $obj_form->install_ac_capacity->setValue($obj_asitcaseinstall->get_install_ac_capacity());
                $obj_form->install_srn->setValue($obj_asitcaseinstall->get_install_srn());
                $obj_form->install_unique_id->setValue($obj_asitcaseinstall->get_install_unique_id());
                $obj_form->install_date->setValue($obj_asitcaseinstall->get_install_date());
                $obj_form->install_old_make->setValue($obj_asitcaseinstall->get_install_old_make());
                $obj_form->install_old_model->setValue($obj_asitcaseinstall->get_install_old_model());
                $obj_form->install_old_capacity->setValue($obj_asitcaseinstall->get_install_old_capacity());
                $obj_form->install_old_vendor->setValue($obj_asitcaseinstall->get_install_old_vendor());
                $obj_form->install_old_year->setValue($obj_asitcaseinstall->get_install_old_year());
                $obj_form->install_old_srn->setValue($obj_asitcaseinstall->get_install_old_srn());
                $obj_form->install_old_watt->setValue($obj_asitcaseinstall->get_install_old_watt());
                $obj_form->install_old_dispose->setValue($obj_asitcaseinstall->get_install_old_dispose());
                $obj_account = new Application_Model_AccountLogic(-1);
                $invoice = $obj_account->getActiveInvoiceByCase($obj_asitcaseinstall->get_case_id());
                $obj_form->install_pay_mode->setValue($invoice['invoice_pay_mode']);
                $obj_form->install_remarks->setValue($obj_asitcaseinstall->get_install_remarks());
                $this->view->form = $obj_form;
                $this->view->caseId = $enc->hideContent($obj_asitcaseinstall->get_case_id());
            }else if($this->_getParam("caseId") != null) {
                $this->view->caseId = $this->_getParam("caseId");
                $caseId = $enc->showHiddenContent($this->_getParam("caseId"));
                $obj_form->case_id->setValue($caseId);
                $this->view->form = $obj_form;
            }
            if($this->getRequest()->isPost()){
                $data=$this->getRequest()->getPost();
                if($obj_form->isValid($data)){
                    $obj_asitcaseinstall = new Application_Model_InstallLogic(-1);
                    $obj_asitcaseinstall->convertToArchive($obj_form->case_id->getValue());
                    $obj_asitcaseinstall->set_case_id($obj_form->case_id->getValue());
                    $obj_asitcaseinstall->set_install_ac_make($obj_form->install_ac_make->getValue());
                    $obj_asitcaseinstall->set_install_ac_model($obj_form->install_ac_model->getValue());
                    $obj_asitcaseinstall->set_install_ac_capacity($obj_form->install_ac_capacity->getValue());
                    $obj_asitcaseinstall->set_install_srn($obj_form->install_srn->getValue());
                    $obj_asitcaseinstall->set_install_date($obj_form->install_date->getValue());
                    $obj_asitcaseinstall->set_install_unique_id($obj_form->install_unique_id->getValue());
                    $obj_asitcaseinstall->set_install_old_make($obj_form->install_old_make->getValue());
                    $obj_asitcaseinstall->set_install_old_model($obj_form->install_old_model->getValue());
                    $obj_asitcaseinstall->set_install_old_capacity($obj_form->install_old_capacity->getValue());
                    $obj_asitcaseinstall->set_install_old_year($obj_form->install_old_year->getValue());
                    $obj_asitcaseinstall->set_install_old_vendor($obj_form->install_old_vendor->getValue());
                    $obj_asitcaseinstall->set_install_old_srn($obj_form->install_old_srn->getValue());
                    $obj_asitcaseinstall->set_install_old_watt($obj_form->install_old_watt->getValue());
                    $obj_asitcaseinstall->set_install_old_dispose($obj_form->install_old_dispose->getValue());
                    $obj_asitcaseinstall->set_install_remarks($obj_form->install_remarks->getValue());
                    $obj_asitcaseinstall->set_install_status('A');
                    $user = new Application_Model_UserLogic(-1);
                    $obj_asitcaseinstall->set_install_updated_by($user->getLoggedInUserId());
                    $obj_asitcaseinstall->set_install_created_by($user->getLoggedInUserId());
                    $obj_asitcaseinstall->save();
                    $obj_inv = new Application_Model_AccountLogic(-1);
                    $obj_inv->setPaymentModeByCase($obj_form->case_id->getValue(), $obj_form->install_pay_mode->getValue());
                    
                    $obj_case = new Application_Model_CaseLogic(-1);
                    $obj_case->updateCaseStatus($caseId, Application_Model_CaseStatus::CASE_STATUS_ID_INSTALLED);

                    $sess = new Zend_Session_Namespace("msg");
                    $sess->msg = "Case has been scheduled successfully!!!";
                    $this->_redirect("dynasty/case/view/id/".$enc->hideContent($obj_form->case_id->getValue()));
                }
            }
        }else {
            throw new Zend_Controller_Action_Exception(Application_Model_Cache_Config::getConfig('AUTHENTICATION_ERROR'), 404);
        }
    }
    
    public function invoiceAction()
    {
        if(Application_Model_RolePermissionLogic::isPermitted("Case:Invoice:Add") || Application_Model_RolePermissionLogic::isPermitted("Case:Invoice:Edit")) {
            $enc = new Application_Model_Util_Encrypt();
            $obj_form = new Application_Form_Invoice();
            if($this->_getParam("id") != null) {
                $id = $enc->showHiddenContent($this->_getParam("id"));
                $obj_asitcaseaccount = new Application_Model_AccountLogic($id);
                $obj_form->case_id->setValue($obj_asitcaseaccount->get_case_id());
                $obj_form->invoice_num->setValue($obj_asitcaseaccount->get_invoice_num());
                $obj_form->invoice_date->setValue($obj_asitcaseaccount->get_invoice_date());
                $obj_form->invoice_net_amount->setValue($obj_asitcaseaccount->get_invoice_net_amount());
                $obj_form->invoice_rebate_amount->setValue($obj_asitcaseaccount->get_invoice_rebate_amount());
                $obj_form->invoice_disposal_amount->setValue($obj_asitcaseaccount->get_invoice_disposal_amount());
                $obj_form->invoice_remarks->setValue($obj_asitcaseaccount->get_invoice_remarks());
                $this->view->form = $obj_form;
                $this->view->caseId = $enc->hideContent($obj_asitcaseaccount->get_case_id());
            }else if($this->_getParam("caseId") != null) {
                $this->view->caseId = $this->_getParam("caseId");
                $caseId = $enc->showHiddenContent($this->_getParam("caseId"));
                $obj_form->case_id->setValue($caseId);
                $this->view->form = $obj_form;
            }
            if($this->getRequest()->isPost()){
                $data=$this->getRequest()->getPost();
                if($obj_form->isValid($data)){
                    $obj_asitcaseaccount = new Application_Model_AccountLogic(-1);
                    $obj_asitcaseaccount->convertToArchive($obj_form->case_id->getValue());
                    $obj_asitcaseaccount->set_case_id($obj_form->case_id->getValue());
                    $obj_asitcaseaccount->set_invoice_num($obj_form->invoice_num->getValue());
                    $obj_asitcaseaccount->set_invoice_date($obj_form->invoice_date->getValue());
                    $obj_asitcaseaccount->set_invoice_net_amount($obj_form->invoice_net_amount->getValue());
                    $obj_asitcaseaccount->set_invoice_rebate_amount($obj_form->invoice_rebate_amount->getValue());
                    $obj_asitcaseaccount->set_invoice_disposal_amount($obj_form->invoice_disposal_amount->getValue());
                    $obj_asitcaseaccount->set_invoice_pay_mode('');
                    $obj_asitcaseaccount->set_invoice_is_paid('');
                    $obj_asitcaseaccount->set_invoice_remarks($obj_form->invoice_remarks->getValue());
                    $obj_asitcaseaccount->set_invoice_status('A');
                    $user = new Application_Model_UserLogic(-1);
                    $obj_asitcaseaccount->set_invoice_updated_by($user->getLoggedInUserId());
                    $obj_asitcaseaccount->set_invoice_created_by($user->getLoggedInUserId());
                    $obj_asitcaseaccount->save();
                    
                    $obj_case = new Application_Model_CaseLogic(-1);
                    $obj_case->updateCaseStatus($caseId, Application_Model_CaseStatus::CASE_STATUS_ID_INVOICE);

                    $sess = new Zend_Session_Namespace("msg");
                    $sess->msg = "Invoice information has been updated!!!";
                    $this->_redirect("dynasty/case/view/id/".$enc->hideContent($obj_form->case_id->getValue()));
                }
            }
        }else {
            throw new Zend_Controller_Action_Exception(Application_Model_Cache_Config::getConfig('AUTHENTICATION_ERROR'), 404);
        }
    }

    public function closeAction()
    {
        if(Application_Model_RolePermissionLogic::isPermitted("Case:Close")) {
            $enc = new Application_Model_Util_Encrypt();
            $this->view->caseId = $this->_getParam("caseId");
            $caseId = $enc->showHiddenContent($this->_getParam("caseId"));
            $obj_acc = new Application_Model_AccountLogic(-1);
            $obj_acc->setCasePaid($caseId);
            $obj_case = new Application_Model_CaseLogic(-1);
            $obj_case->updateCaseStatus($caseId, Application_Model_CaseStatus::CASE_STATUS_ID_CLOSED);
            
            $sess = new Zend_Session_Namespace("msg");
            $sess->msg = "Case has been closed successfully89!!!";
            $this->_redirect("dynasty/case/view/id/".$enc->hideContent($caseId));
            
        }else {
            throw new Zend_Controller_Action_Exception(Application_Model_Cache_Config::getConfig('AUTHENTICATION_ERROR'), 404);
        }
    }

    public function schedLogAction()
    {
        if(Application_Model_RolePermissionLogic::isPermitted("Case:Schedule:Log")) {
            $enc = new Application_Model_Util_Encrypt();
            $this->view->caseId = $this->_getParam("caseId");
            $caseId = $enc->showHiddenContent($this->_getParam("caseId"));
            $cur_page=1;
            if($this->_getParam("page")!=null)

            $cur_page=(int)$this->_getParam("page");

            $obj_sched = new Application_Model_ScheduleLogic(-1);
            $results = $obj_sched->getCaseLog($caseId);

            $adapter = new Zend_Paginator_Adapter_DbSelect($results);

            $paginator = new  Zend_Paginator($adapter);


            $paginator->setItemCountPerPage(10);
            $paginator->setCurrentPageNumber($cur_page);


            $this->view->paginator = $paginator;

            Zend_Paginator::setDefaultScrollingStyle("Sliding");
            Zend_View_Helper_PaginationControl::setDefaultViewPartial(
            "pagination.phtml"
            );
        }else {
            throw new Zend_Controller_Action_Exception(Application_Model_Cache_Config::getConfig('AUTHENTICATION_ERROR'), 404);
        }
    }
    
    public function installLogAction()
    {
        if(Application_Model_RolePermissionLogic::isPermitted("Case:Install:Log")) {
            $enc = new Application_Model_Util_Encrypt();
            $this->view->caseId = $this->_getParam("caseId");
            $caseId = $enc->showHiddenContent($this->_getParam("caseId"));
            $cur_page=1;
            if($this->_getParam("page")!=null)

            $cur_page=(int)$this->_getParam("page");

            $obj_install = new Application_Model_InstallLogic(-1);
            $results = $obj_install->getCaseLog($caseId);

            $adapter = new Zend_Paginator_Adapter_DbSelect($results);

            $paginator = new  Zend_Paginator($adapter);


            $paginator->setItemCountPerPage(10);
            $paginator->setCurrentPageNumber($cur_page);


            $this->view->paginator = $paginator;

            Zend_Paginator::setDefaultScrollingStyle("Sliding");
            Zend_View_Helper_PaginationControl::setDefaultViewPartial(
            "pagination.phtml"
            );
        }else {
            throw new Zend_Controller_Action_Exception(Application_Model_Cache_Config::getConfig('AUTHENTICATION_ERROR'), 404);
        }
    }
    
    public function invoiceLogAction()
    {
        if(Application_Model_RolePermissionLogic::isPermitted("Case:Invoice:Log")) {
            $enc = new Application_Model_Util_Encrypt();
            $this->view->caseId = $this->_getParam("caseId");
            $caseId = $enc->showHiddenContent($this->_getParam("caseId"));
            $cur_page=1;
            if($this->_getParam("page")!=null)

            $cur_page=(int)$this->_getParam("page");

            $obj_inv = new Application_Model_AccountLogic(-1);
            $results = $obj_inv->getCaseLog($caseId);

            $adapter = new Zend_Paginator_Adapter_DbSelect($results);

            $paginator = new  Zend_Paginator($adapter);


            $paginator->setItemCountPerPage(10);
            $paginator->setCurrentPageNumber($cur_page);


            $this->view->paginator = $paginator;

            Zend_Paginator::setDefaultScrollingStyle("Sliding");
            Zend_View_Helper_PaginationControl::setDefaultViewPartial(
            "pagination.phtml"
            );
        }else {
            throw new Zend_Controller_Action_Exception(Application_Model_Cache_Config::getConfig('AUTHENTICATION_ERROR'), 404);
        }
    }
}

